(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/platform-browser'), require('rxjs'), require('@angular/router'), require('rxjs/operators'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@anjuna/angular-docs', ['exports', '@angular/core', '@angular/platform-browser', 'rxjs', '@angular/router', 'rxjs/operators', '@angular/common'], factory) :
    (global = global || self, factory((global.anjuna = global.anjuna || {}, global.anjuna['angular-docs'] = {}), global.ng.core, global.ng.platformBrowser, global.rxjs, global.ng.router, global.rxjs.operators, global.ng.common));
}(this, (function (exports, core, platformBrowser, rxjs, router, operators, common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DocsService = /** @class */ (function () {
        function DocsService() {
            this._menuItems$ = new rxjs.BehaviorSubject(null);
        }
        Object.defineProperty(DocsService.prototype, "menuItems$", {
            get: /**
             * @return {?}
             */
            function () {
                return this._menuItems$.asObservable();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DocsService.prototype, "menuItems", {
            set: /**
             * @param {?} items
             * @return {?}
             */
            function (items) {
                this._menuItems = items;
                this._menuItems$.next(items);
            },
            enumerable: true,
            configurable: true
        });
        DocsService.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ DocsService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function DocsService_Factory() { return new DocsService(); }, token: DocsService, providedIn: "root" });
        return DocsService;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        DocsService.prototype._menuItems$;
        /**
         * @type {?}
         * @private
         */
        DocsService.prototype._menuItems;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var baseTitle = (/**
     * @param {?} title
     * @return {?}
     */
    function (title) {
        return title.includes('|') ? title.split(' | ')[0] : title;
    });
    /** @type {?} */
    var titleFromName = (/**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        return name.split(/(?=[A-Z])/).join(' ');
    });
    /** @type {?} */
    var titleFromTag = (/**
     * @param {?} tag
     * @return {?}
     */
    function (tag) {
        return tag.split('-').slice(1).map((/**
         * @param {?} word
         * @return {?}
         */
        function (word) { return word.charAt(0).toUpperCase() + word.slice(1); })).join(' ');
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ApiComponent = /** @class */ (function () {
        function ApiComponent(title, service) {
            this.title = title;
            this.service = service;
            this.service.menuItems = undefined;
            this.title.setTitle(baseTitle(this.title.getTitle()) + " | API");
        }
        ApiComponent.decorators = [
            { type: core.Component, args: [{
                        template: '<router-outlet></router-outlet>',
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        ApiComponent.ctorParameters = function () { return [
            { type: platformBrowser.Title },
            { type: DocsService }
        ]; };
        return ApiComponent;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        ApiComponent.prototype.title;
        /**
         * @type {?}
         * @private
         */
        ApiComponent.prototype.service;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var FrameworkType = {
        angular: 'angular',
        javascript: 'javascript',
        vue: 'vue',
    };
    /**
     * @record
     */
    function ApiDocs() { }
    /** @type {?} */
    var DEMO_COMPONENTS = new core.InjectionToken('Demo components');
    /** @type {?} */
    var GET_STARTED_URL = new core.InjectionToken('URL to get started from home');
    /** @type {?} */
    var HOME_README = new core.InjectionToken('Injectable Home Readme');
    /** @type {?} */
    var LIBRARY_API = new core.InjectionToken('The full library API');
    /** @type {?} */
    var MODULE_DOCS = new core.InjectionToken('Demo components');
    /** @type {?} */
    var MODULE_GET_STARTED_URL = new core.InjectionToken('URL to try a module');
    /** @type {?} */
    var MODULE_NAME = new core.InjectionToken('Module name');
    /** @type {?} */
    var MODULE_README = new core.InjectionToken('Injectable Web Components Readme');
    /** @type {?} */
    var MODULE_TYPE = new core.InjectionToken('The framework the module is for');

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ApiDocComponent = /** @class */ (function () {
        function ApiDocComponent(title, route, api) {
            var _this = this;
            this.title = title;
            this.route = route;
            /** @type {?} */
            var module = this.route.snapshot.paramMap.get('module');
            this.id = this.route.snapshot.paramMap.get('id');
            this.doc = api[module].find((/**
             * @param {?} d
             * @return {?}
             */
            function (d) { return d.tag ? d.tag === _this.id : d.name === _this.id; }));
            this.title.setTitle(baseTitle(this.title.getTitle()) + " | " + this.id);
        }
        ApiDocComponent.decorators = [
            { type: core.Component, args: [{
                        template: "<article class=\"component-readme\">\n    <div class=\"breadcrumbs\">\n        <a [routerLink]=\"['../../']\">API</a><span class=\"sep\">/</span><span class=\"id\">{{id}}</span>\n    </div>\n    <ad-markdown [data]=\"doc.readme\"></ad-markdown>\n    <ad-api [doc]=\"doc\"></ad-api>\n</article>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        styles: [":host{display:block}:host .breadcrumbs{margin-bottom:1rem}:host .breadcrumbs .sep{color:var(--anj-border-dark);margin:0 .5rem}:host .breadcrumbs .id{color:var(--anj-neutral)}"]
                    }] }
        ];
        /** @nocollapse */
        ApiDocComponent.ctorParameters = function () { return [
            { type: platformBrowser.Title },
            { type: router.ActivatedRoute },
            { type: undefined, decorators: [{ type: core.Inject, args: [LIBRARY_API,] }] }
        ]; };
        return ApiDocComponent;
    }());
    if (false) {
        /** @type {?} */
        ApiDocComponent.prototype.doc;
        /** @type {?} */
        ApiDocComponent.prototype.id;
        /**
         * @type {?}
         * @private
         */
        ApiDocComponent.prototype.title;
        /**
         * @type {?}
         * @private
         */
        ApiDocComponent.prototype.route;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ApiListComponent = /** @class */ (function () {
        function ApiListComponent(api) {
            this.api = api;
            this.filtered = this.api;
        }
        /**
         * @param {?} __0
         * @return {?}
         */
        ApiListComponent.prototype.filter = /**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var _this = this;
            var detail = _a.detail;
            /** @type {?} */
            var query = detail.value.toLowerCase();
            /** @type {?} */
            var filtered = {};
            for (var module in this.api) {
                if (this.api.hasOwnProperty(module)) {
                    /** @type {?} */
                    var mFiltered = this.api[module].filter((/**
                     * @param {?} d
                     * @return {?}
                     */
                    function (d) { return _this.nameFromDoc(d).toLowerCase().includes(query); }));
                    if (mFiltered.length > 0) {
                        filtered[module] = mFiltered;
                    }
                }
            }
            this.filtered = Object.keys(filtered).length > 0 ? filtered : undefined;
        };
        /**
         * @param {?} module
         * @param {?} doc
         * @return {?}
         */
        ApiListComponent.prototype.apiPath = /**
         * @param {?} module
         * @param {?} doc
         * @return {?}
         */
        function (module, doc) {
            return module + "/" + this.nameFromDoc(doc);
        };
        /**
         * @param {?} doc
         * @return {?}
         */
        ApiListComponent.prototype.nameFromDoc = /**
         * @param {?} doc
         * @return {?}
         */
        function (doc) {
            return doc.tag ? doc.tag : doc.name;
        };
        ApiListComponent.decorators = [
            { type: core.Component, args: [{
                        template: "<anj-form-group>\n    <anj-filter placeholder=\"Search\" (anjFilter)=\"filter($event)\"></anj-filter>\n</anj-form-group>\n<ng-container *ngIf=\"filtered; else noResults\">\n    <section *ngFor=\"let lib of filtered | keyvalue\">\n        <anj-headline><h3>{{lib.key}}</h3></anj-headline>\n        <div class=\"row results-container\">\n            <div *ngFor=\"let doc of lib.value\" class=\"col-12 col-sm-6 col-md-4 col-lg-3 result\">\n                <a [routerLink]=\"apiPath(lib.key, doc)\">{{nameFromDoc(doc)}}</a>\n            </div>\n        </div>\n    </section>\n</ng-container>\n<ng-template #noResults>\n    <p>No matches found.</p>\n</ng-template>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        styles: [":host{display:block}:host anj-headline{border-bottom:1px solid var(--anj-border);padding-bottom:.75rem;margin-bottom:1rem}:host .results-container{margin-bottom:2rem}:host .result{margin-bottom:.5rem}"]
                    }] }
        ];
        /** @nocollapse */
        ApiListComponent.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [LIBRARY_API,] }] }
        ]; };
        return ApiListComponent;
    }());
    if (false) {
        /** @type {?} */
        ApiListComponent.prototype.filtered;
        /** @type {?} */
        ApiListComponent.prototype.api;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var LIBRARY_VERSION = new core.InjectionToken('LibraryVersion');
    var VersionPipe = /** @class */ (function () {
        function VersionPipe(version) {
            this.version = version;
        }
        /**
         * @param {?} value
         * @return {?}
         */
        VersionPipe.prototype.transform = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (!this.version) {
                return value;
            }
            /** @type {?} */
            var val = value.default ? value.default : value;
            return val.replace(/0.0.0/g, this.version);
        };
        VersionPipe.decorators = [
            { type: core.Pipe, args: [{
                        name: 'version'
                    },] }
        ];
        /** @nocollapse */
        VersionPipe.ctorParameters = function () { return [
            { type: String, decorators: [{ type: core.Optional }, { type: core.Inject, args: [LIBRARY_VERSION,] }] }
        ]; };
        return VersionPipe;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        VersionPipe.prototype.version;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ExternalDocComponent = /** @class */ (function () {
        function ExternalDocComponent(docs, route, version) {
            var _this = this;
            this.docs = docs;
            this.route = route;
            this.version = version;
            this.doc$ = this.route.paramMap.pipe(operators.switchMap((/**
             * @param {?} params
             * @return {?}
             */
            function (params) { return rxjs.of(version.transform(_this.docs[params.get('id')])); })));
        }
        ExternalDocComponent.decorators = [
            { type: core.Component, args: [{
                        template: '<ad-markdown [data]="doc$ | async"></ad-markdown>',
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        ExternalDocComponent.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [MODULE_DOCS,] }] },
            { type: router.ActivatedRoute },
            { type: VersionPipe }
        ]; };
        return ExternalDocComponent;
    }());
    if (false) {
        /** @type {?} */
        ExternalDocComponent.prototype.doc$;
        /**
         * @type {?}
         * @private
         */
        ExternalDocComponent.prototype.docs;
        /**
         * @type {?}
         * @private
         */
        ExternalDocComponent.prototype.route;
        /**
         * @type {?}
         * @private
         */
        ExternalDocComponent.prototype.version;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ExternalModuleComponent = /** @class */ (function () {
        function ExternalModuleComponent(docs, name, service) {
            this.docs = docs;
            this.name = name;
            this.service = service;
            /** @type {?} */
            var path = name.toLowerCase();
            this.service.menuItems = Object.keys(docs).map((/**
             * @param {?} doc
             * @return {?}
             */
            function (doc) {
                return {
                    link: path + "/" + doc,
                    name: doc.split('-').join(' ')
                };
            }));
        }
        ExternalModuleComponent.decorators = [
            { type: core.Component, args: [{
                        template: '<router-outlet></router-outlet>',
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        ExternalModuleComponent.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [MODULE_DOCS,] }] },
            { type: String, decorators: [{ type: core.Inject, args: [MODULE_NAME,] }] },
            { type: DocsService }
        ]; };
        return ExternalModuleComponent;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        ExternalModuleComponent.prototype.docs;
        /**
         * @type {?}
         * @private
         */
        ExternalModuleComponent.prototype.name;
        /**
         * @type {?}
         * @private
         */
        ExternalModuleComponent.prototype.service;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FeatureComponent = /** @class */ (function () {
        function FeatureComponent(route, changeRef, title, docs, frameWorkType) {
            var _this = this;
            this.route = route;
            this.changeRef = changeRef;
            this.title = title;
            this.docs = docs;
            this.frameWorkType = frameWorkType;
            this.route.params.subscribe({
                next: (/**
                 * @param {?} params
                 * @return {?}
                 */
                function (params) {
                    /** @type {?} */
                    var doc = _this.docs.find((/**
                     * @param {?} d
                     * @return {?}
                     */
                    function (d) {
                        return d.tag ? d.tag === params.id : d.name === params.id;
                    }));
                    _this.doc = _this.filterExamples(doc);
                    _this.title.setTitle(_this.titleFromDoc(_this.title.getTitle()));
                    _this.changeRef.markForCheck();
                })
            });
        }
        /**
         * @param {?} usages
         * @return {?}
         */
        FeatureComponent.prototype.sortedKeys = /**
         * @param {?} usages
         * @return {?}
         */
        function (usages) {
            /** @type {?} */
            var keys = Object.keys(usages);
            /** @type {?} */
            var firstIndex = keys.findIndex((/**
             * @param {?} k
             * @return {?}
             */
            function (k) { return k === 'usage' || k === 'angular' || k === 'vue'; }));
            return keys.splice(firstIndex, 1).concat(keys);
        };
        /**
         * @private
         * @param {?} title
         * @return {?}
         */
        FeatureComponent.prototype.titleFromDoc = /**
         * @private
         * @param {?} title
         * @return {?}
         */
        function (title) {
            /** @type {?} */
            var base = baseTitle(title);
            if (!this.doc) {
                return base;
            }
            return base + " | " + (this.doc.tag ? titleFromTag(this.doc.tag) : titleFromName(this.doc.name));
        };
        /**
         * @private
         * @param {?} doc
         * @return {?}
         */
        FeatureComponent.prototype.filterExamples = /**
         * @private
         * @param {?} doc
         * @return {?}
         */
        function (doc) {
            if (this.frameWorkType === FrameworkType.angular) {
                return this.getNgExamples(doc);
            }
            else if (this.frameWorkType === FrameworkType.vue) {
                return this.getVueExamples(doc);
            }
            else if (this.frameWorkType === FrameworkType.javascript) {
                return this.getJsExamples(doc);
            }
            return doc;
        };
        // Return ng examples, if existing. Otherwise, js examples.
        // Return ng examples, if existing. Otherwise, js examples.
        /**
         * @param {?} doc
         * @return {?}
         */
        FeatureComponent.prototype.getNgExamples = 
        // Return ng examples, if existing. Otherwise, js examples.
        /**
         * @param {?} doc
         * @return {?}
         */
        function (doc) {
            /** @type {?} */
            var usages = {};
            if (doc.usage.angular) {
                for (var u in doc.usage) {
                    if (u === 'angular' || u.startsWith('ng-')) {
                        usages[u] = doc.usage[u];
                    }
                }
                doc.usage = usages;
                return doc;
            }
            else {
                return this.getJsExamples(doc);
            }
        };
        // Return js examples.
        // Return js examples.
        /**
         * @param {?} doc
         * @return {?}
         */
        FeatureComponent.prototype.getJsExamples = 
        // Return js examples.
        /**
         * @param {?} doc
         * @return {?}
         */
        function (doc) {
            /** @type {?} */
            var usages = {};
            for (var u in doc.usage) {
                if (u !== 'angular' && !u.startsWith('ng-') &&
                    u !== 'vue' && !u.startsWith('vue-')) {
                    usages[u] = doc.usage[u];
                }
            }
            doc.usage = usages;
            return doc;
        };
        // Return vue examples, if existing. Otherwise, js examples.
        // Return vue examples, if existing. Otherwise, js examples.
        /**
         * @param {?} doc
         * @return {?}
         */
        FeatureComponent.prototype.getVueExamples = 
        // Return vue examples, if existing. Otherwise, js examples.
        /**
         * @param {?} doc
         * @return {?}
         */
        function (doc) {
            /** @type {?} */
            var usages = {};
            if (doc.usage.vue) {
                for (var u in doc.usage) {
                    if (u === 'vue' || u.startsWith('vue-')) {
                        usages[u] = doc.usage[u];
                    }
                }
                doc.usage = usages;
                return doc;
            }
            else {
                return this.getJsExamples(doc);
            }
        };
        FeatureComponent.decorators = [
            { type: core.Component, args: [{
                        template: "<div class=\"row\">\n    <div [ngClass]=\"doc.usage ? 'col-12 col-lg-10' : 'col-12'\">\n        <article class=\"component-readme\" id=\"overview\">\n            <ad-markdown [data]=\"doc.readme\"></ad-markdown>\n        </article>\n        <article *ngFor=\"let key of sortedKeys(doc.usage)\" id=\"{{key}}\">\n            <ad-use-case [usage]=\"doc.usage[key]\"></ad-use-case>\n        </article>\n        <ad-api [doc]=\"doc\"></ad-api>\n    </div>\n    <div *ngIf=\"doc.usage\" class=\"d-none d-lg-flex col-lg-2 toc-wrapper\">\n        <ad-toc [docs]=\"doc.usage\" [keys]=\"sortedKeys(doc.usage)\"></ad-toc>\n    </div>\n</div>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        styles: [".component-readme{margin-bottom:2.5rem}"]
                    }] }
        ];
        /** @nocollapse */
        FeatureComponent.ctorParameters = function () { return [
            { type: router.ActivatedRoute },
            { type: core.ChangeDetectorRef },
            { type: platformBrowser.Title },
            { type: Array, decorators: [{ type: core.Inject, args: [MODULE_DOCS,] }] },
            { type: FrameworkType, decorators: [{ type: core.Optional }, { type: core.Inject, args: [MODULE_TYPE,] }] }
        ]; };
        return FeatureComponent;
    }());
    if (false) {
        /** @type {?} */
        FeatureComponent.prototype.doc;
        /** @type {?} */
        FeatureComponent.prototype.demos;
        /**
         * @type {?}
         * @private
         */
        FeatureComponent.prototype.route;
        /**
         * @type {?}
         * @private
         */
        FeatureComponent.prototype.changeRef;
        /**
         * @type {?}
         * @private
         */
        FeatureComponent.prototype.title;
        /**
         * @type {?}
         * @private
         */
        FeatureComponent.prototype.docs;
        /**
         * @type {?}
         * @private
         */
        FeatureComponent.prototype.frameWorkType;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var HomeComponent = /** @class */ (function () {
        function HomeComponent(title, service, getStartedUrl, readme) {
            this.title = title;
            this.service = service;
            this.getStartedUrl = getStartedUrl;
            this.readme = readme;
            this.service.menuItems = null;
            this.title.setTitle(baseTitle(this.title.getTitle()));
        }
        HomeComponent.decorators = [
            { type: core.Component, args: [{
                        template: "<article>\n    <ad-markdown [data]=\"readme\"></ad-markdown>\n    <p *ngIf=\"getStartedUrl\" class=\"text-center pt-4\">\n        <anj-button [routerLink]=\"getStartedUrl\">Get Started</anj-button>\n    </p>\n</article>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        HomeComponent.ctorParameters = function () { return [
            { type: platformBrowser.Title },
            { type: DocsService },
            { type: String, decorators: [{ type: core.Optional }, { type: core.Inject, args: [GET_STARTED_URL,] }] },
            { type: String, decorators: [{ type: core.Inject, args: [HOME_README,] }] }
        ]; };
        return HomeComponent;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        HomeComponent.prototype.title;
        /**
         * @type {?}
         * @private
         */
        HomeComponent.prototype.service;
        /** @type {?} */
        HomeComponent.prototype.getStartedUrl;
        /** @type {?} */
        HomeComponent.prototype.readme;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var IntroComponent = /** @class */ (function () {
        function IntroComponent(title, readme, moduleName, getStartedUrl) {
            this.title = title;
            this.readme = readme;
            this.moduleName = moduleName;
            this.getStartedUrl = getStartedUrl;
            this.title.setTitle(baseTitle(this.title.getTitle()) + " | " + moduleName);
        }
        IntroComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ad-components',
                        template: "<article>\n    <ad-markdown [data]=\"readme | version\"></ad-markdown>\n    <p *ngIf=\"getStartedUrl\" class=\"text-center pt-4\">\n        <anj-button [routerLink]=\"getStartedUrl\">Try It</anj-button>\n    </p>\n</article>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        styles: [":host::ng-deep ad-markdown p[align=center]{display:none}"]
                    }] }
        ];
        /** @nocollapse */
        IntroComponent.ctorParameters = function () { return [
            { type: platformBrowser.Title },
            { type: String, decorators: [{ type: core.Inject, args: [MODULE_README,] }] },
            { type: String, decorators: [{ type: core.Inject, args: [MODULE_NAME,] }] },
            { type: String, decorators: [{ type: core.Optional }, { type: core.Inject, args: [MODULE_GET_STARTED_URL,] }] }
        ]; };
        return IntroComponent;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        IntroComponent.prototype.title;
        /** @type {?} */
        IntroComponent.prototype.readme;
        /**
         * @type {?}
         * @private
         */
        IntroComponent.prototype.moduleName;
        /** @type {?} */
        IntroComponent.prototype.getStartedUrl;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function ComponentDoc() { }
    if (false) {
        /** @type {?} */
        ComponentDoc.prototype.methods;
        /** @type {?} */
        ComponentDoc.prototype.props;
        /** @type {?} */
        ComponentDoc.prototype.readme;
        /** @type {?} */
        ComponentDoc.prototype.usage;
        /** @type {?} */
        ComponentDoc.prototype.tag;
        /** @type {?} */
        ComponentDoc.prototype.name;
        /** @type {?} */
        ComponentDoc.prototype.link;
        /** @type {?|undefined} */
        ComponentDoc.prototype.events;
        /** @type {?|undefined} */
        ComponentDoc.prototype.outputs;
        /** @type {?|undefined} */
        ComponentDoc.prototype.inputs;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function ADMenuItem() { }
    if (false) {
        /** @type {?} */
        ADMenuItem.prototype.link;
        /** @type {?} */
        ADMenuItem.prototype.name;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function DocsMap() { }
    /**
     * @record
     */
    function UsageContext() { }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var   /**
     * @abstract
     */
    JsDemo = /** @class */ (function () {
        function JsDemo(element, demo) {
            element.nativeElement.appendChild(document.createRange().createContextualFragment(demo));
        }
        return JsDemo;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UseCaseComponent = /** @class */ (function () {
        function UseCaseComponent(sanitizer) {
            this.sanitizer = sanitizer;
        }
        /**
         * @return {?}
         */
        UseCaseComponent.prototype.ngOnChanges = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var docs = this.usage.split('<!-- Demo -->');
            this.doc = docs[0].trim();
            this.demo = docs[1] ? this.sanitizer.bypassSecurityTrustHtml(docs[1] ? docs[1].trim() : '') : undefined;
            if (docs[2]) {
                /** @type {?} */
                var tabs_1 = {};
                docs[2].trim().split('```').forEach((/**
                 * @param {?} s
                 * @return {?}
                 */
                function (s) {
                    s = s.trim();
                    if (s) {
                        tabs_1[s.split(/\n/)[0].trim()] = "" + '```' + s + '```';
                    }
                }));
                this.tabs = tabs_1;
            }
        };
        /**
         * @param {?=} tab
         * @return {?}
         */
        UseCaseComponent.prototype.switchTabs = /**
         * @param {?=} tab
         * @return {?}
         */
        function (tab) {
            this.activeTab = tab ? tab : this.activeTab ? undefined : Object.keys(this.tabs)[0];
        };
        /**
         * @param {?} doc
         * @return {?}
         */
        UseCaseComponent.prototype.getTitle = /**
         * @param {?} doc
         * @return {?}
         */
        function (doc) {
            return doc.split('\n')[0].replace(/#/g, '').trim();
        };
        /**
         * @param {?} type
         * @return {?}
         */
        UseCaseComponent.prototype.codeType = /**
         * @param {?} type
         * @return {?}
         */
        function (type) {
            return type.includes('typescript') ? 'ts' : type;
        };
        UseCaseComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ad-use-case',
                        template: "<ad-markdown [data]=\"doc\"></ad-markdown>\n<anj-card *ngIf=\"demo\" elevation=\"1\">\n    <anj-card-header>\n        <anj-headline>\n            <h3>{{getTitle(doc)}}</h3>\n            <anj-button context=\"icon\" (click)=\"switchTabs()\" title=\"View Source\">\n                <svg slot=\"icon-only\" xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" viewBox=\"0 0 24 24\">\n                    <path d=\"M9.4 16.6L4.8 12l4.6-4.6L8 6l-6 6 6 6 1.4-1.4zm5.2 0l4.6-4.6-4.6-4.6L16 6l6 6-6 6-1.4-1.4z\"/>\n                </svg>\n            </anj-button>\n        </anj-headline>\n    </anj-card-header>\n    <anj-card-body>\n        <div class=\"example-container\" [class.anj-active]=\"activeTab\">\n            <anj-tabs>\n                <anj-tab *ngFor=\"let t of tabs | keyvalue\" (click)=\"switchTabs(t.key)\" [class.anj-active]=\"t.key === activeTab\">{{codeType(t.key)}}</anj-tab>\n            </anj-tabs>\n            <div class=\"example\">\n                <ad-markdown *ngFor=\"let t of tabs | keyvalue\" [data]=\"t.value\" [class.anj-active]=\"t.key === activeTab\"></ad-markdown>\n            </div>\n        </div>\n        <div *ngIf=\"demo\" class=\"demo-container\" [innerHTML]=\"demo\"></div>\n    </anj-card-body>\n</anj-card>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        styles: [":host{border-bottom:1px solid var(--anj-border);display:block;margin-bottom:3rem;padding-bottom:3.5rem}:host anj-card{margin-top:2rem}:host anj-tab{text-transform:uppercase}:host .example-container{margin:0 -1.25rem}:host .example-container:not(.anj-active){height:0;overflow:hidden}:host .example{background-color:var(--anj-background);border-bottom:1px solid var(--anj-border);margin:0 0 1rem;padding:1rem}:host .example ad-markdown{display:none}:host .example ad-markdown.anj-active{display:block}"]
                    }] }
        ];
        /** @nocollapse */
        UseCaseComponent.ctorParameters = function () { return [
            { type: platformBrowser.DomSanitizer }
        ]; };
        UseCaseComponent.propDecorators = {
            usage: [{ type: core.Input }]
        };
        return UseCaseComponent;
    }());
    if (false) {
        /** @type {?} */
        UseCaseComponent.prototype.usage;
        /** @type {?} */
        UseCaseComponent.prototype.activeTab;
        /** @type {?} */
        UseCaseComponent.prototype.doc;
        /** @type {?} */
        UseCaseComponent.prototype.demo;
        /** @type {?} */
        UseCaseComponent.prototype.tabs;
        /**
         * @type {?}
         * @private
         */
        UseCaseComponent.prototype.sanitizer;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AnjunaDocsModule = /** @class */ (function () {
        function AnjunaDocsModule() {
        }
        AnjunaDocsModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            router.RouterModule
                        ],
                        declarations: [
                            ApiComponent,
                            ApiDocComponent,
                            ApiListComponent,
                            ExternalDocComponent,
                            ExternalModuleComponent,
                            FeatureComponent,
                            HomeComponent,
                            IntroComponent,
                            UseCaseComponent,
                            VersionPipe
                        ],
                        exports: [
                            ApiComponent,
                            ApiDocComponent,
                            ApiListComponent,
                            ExternalDocComponent,
                            ExternalModuleComponent,
                            FeatureComponent,
                            HomeComponent,
                            IntroComponent
                        ],
                        entryComponents: [
                            ApiComponent,
                            ApiDocComponent,
                            ApiListComponent,
                            FeatureComponent,
                            HomeComponent,
                            IntroComponent
                        ],
                        providers: [
                            VersionPipe
                        ],
                        schemas: [
                            core.CUSTOM_ELEMENTS_SCHEMA
                        ]
                    },] }
        ];
        return AnjunaDocsModule;
    }());

    exports.AnjunaDocsModule = AnjunaDocsModule;
    exports.ApiComponent = ApiComponent;
    exports.ApiDocComponent = ApiDocComponent;
    exports.ApiListComponent = ApiListComponent;
    exports.DEMO_COMPONENTS = DEMO_COMPONENTS;
    exports.DocsService = DocsService;
    exports.ExternalDocComponent = ExternalDocComponent;
    exports.ExternalModuleComponent = ExternalModuleComponent;
    exports.FeatureComponent = FeatureComponent;
    exports.FrameworkType = FrameworkType;
    exports.GET_STARTED_URL = GET_STARTED_URL;
    exports.HOME_README = HOME_README;
    exports.HomeComponent = HomeComponent;
    exports.IntroComponent = IntroComponent;
    exports.JsDemo = JsDemo;
    exports.LIBRARY_API = LIBRARY_API;
    exports.LIBRARY_VERSION = LIBRARY_VERSION;
    exports.MODULE_DOCS = MODULE_DOCS;
    exports.MODULE_GET_STARTED_URL = MODULE_GET_STARTED_URL;
    exports.MODULE_NAME = MODULE_NAME;
    exports.MODULE_README = MODULE_README;
    exports.MODULE_TYPE = MODULE_TYPE;
    exports.VersionPipe = VersionPipe;
    exports.baseTitle = baseTitle;
    exports.titleFromName = titleFromName;
    exports.titleFromTag = titleFromTag;
    exports.ɵa = UseCaseComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=anjuna-angular-docs.umd.js.map
